; Script generated by the Inno Setup Script Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

#define MyAppName "AMD & Intel AHCI Post-Inistall( ν) for XP"
#define MyAppVersion "1.1"
#define MyAppPublisher "athlon88"
#define MyAppURL "http://bodnara.co.kr"


[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
AppId={{ABAC2B3D-1C22-4DF8-B7A5-768FD3829C69}
AppName={#MyAppName}
AppVersion={#MyAppVersion}
;AppVerName={#MyAppName} {#MyAppVersion}
AppPublisher={#MyAppPublisher}
AppPublisherURL={#MyAppURL}
AppSupportURL={#MyAppURL}
AppUpdatesURL={#MyAppURL}
CreateAppDir=no
OutputBaseFilename=AMDINTEL_AHCI_XPInstall
Compression=lzma
SolidCompression=yes
Uninstallable=no
AlwaysRestart=yes

[code]
const
  { AMD }
  VenderIdStr = 'PCI#VEN_1022&DEV_7801&CC_0106';
  A55GUID = '{4D36E97B-E325-11CE-BFC1-08002BE10318}';
  VenderIdStr7xx = 'PCI#VEN_1002&DEV_4391&CC_0106';

  { intel }
  ICHGUID = '{4D36E96A-E325-11CE-BFC1-08002BE10318}';
  I_V1 = 'PCI#VEN_8086&DEV_27C1&CC_0106';
  I_V2 = 'PCI#VEN_8086&DEV_27C5&CC_0106';
  I_V3 = 'PCI#VEN_8086&DEV_2929&CC_0106';
  I_V4 = 'PCI#VEN_8086&DEV_3A02&CC_0106';
  I_V5 = 'PCI#VEN_8086&DEV_3A22&CC_0106';
  I_V6 = 'PCI#VEN_8086&DEV_3B29&CC_0106';
  I_V7 = 'PCI#VEN_8086&DEV_3B2F&CC_0106';
  I_V8 = 'PCI#VEN_8086&DEV_3B22&CC_0106';
  I_V9 = 'PCI#VEN_8086&DEV_1C02&CC_0106';
  I_Va = 'PCI#VEN_8086&DEV_1C03&CC_0106';
  I_Vb = 'PCI#VEN_8086&DEV_1E02&CC_0106';
  I_Vc = 'PCI#VEN_8086&DEV_1E03&CC_0106';

var
  VenderIdx : Integer;
  ExitCancel : boolean;

function getIntelvender(i : integer):string;
begin
  case i of
  0 : Result:=I_V1;
  1 : Result:=I_V2;
  2 : Result:=I_V3;
  3 : Result:=I_V4;
  4 : Result:=I_V5;
  5 : Result:=I_V6;
  6 : Result:=I_V7;
  7 : Result:=I_V8;
  8 : Result:=I_V9;
  9 : Result:=I_Va;
  10: Result:=I_Vb;
  11: Result:=I_Vc;
  end;
end;

function Ahcidrv(name :string):String;
begin
  if IsWin64 then
    Result:='ahcix64'
    else
      Result:='ahcix86';
end;

function ahciGuid(name :string):String;
begin
  Result:=A55GUID;
end;

function AhcidrvIntel(name : string):String;
begin
   Result:='iaStor';
end;

function ahciGuidIntel(name :string):String;
begin
  Result:=ICHGUID;
end;

function VenderId(name : string):string;
begin
  case VenderIdx of
  0 : Result:=VenderIdStr;
  1 : Result:=VenderIdStr7xx;
  end;      
end;

function IsWin32:Boolean;
begin
  Result:=not IsWin64;
end;

// Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\{code:VenderId}"; ValueType: string; ValueName: "Service"; ValueData: "{code:ahcidrv}";
// Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\{code:VenderId}"; ValueType: string; ValueName: "ClassGUID"; ValueData: "{code:ahciguid}";

procedure WriteDeviceDataBase(VenderStr, DrvName, DrvGuid : string);
begin
  RegWriteStringValue(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\'+VenderStr,'Service',DrvName);
  RegWriteStringValue(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\'+VenderStr,'ClassGUID',DrvGuid);
end;

//;Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrv}"; ValueType: dword; ValueName: "tag"; ValueData: "4"; 

procedure CreateDeviceDatabase;
var i:Integer;
begin
  if WizardForm.ComponentsList.State[0]=cbChecked then
  case VenderIdx of
  0, 1 : WriteDeviceDataBase(VenderId(''),ahcidrv(''),ahciguid(''));
  end;
  if WizardForm.ComponentsList.State[3]=cbChecked then
    for i:=0 to 11 do
           WriteDeviceDatabase(getIntelvender(i),ahcidrvIntel(''),ahciguidIntel(''));
end;

function InitializeSetup(): Boolean;
var
  winver : cardinal;
begin
   Result:=False;
   winver := GetWindowsVersion and $FFFF0000;
   Result := (winver>$050000) and (winver<$06000000);
end;

procedure CurPageChanged(CurPageID: Integer);
begin
  if CurPageID=wpWelcome then begin
    WizardForm.ComponentsList.CheckItem(1,coCheck);
    WizardForm.ComponentsList.ItemIndex:=1;
    ExitCancel:=True;
  end else if CurPageID=wpInstalling then
    CreateDeviceDatabase;
    
end;

procedure CancelButtonClick(CurPageID: Integer; var Cancel, Confirm: Boolean);
begin
  if CurPageID=wpSelectComponents then
    Confirm := ExitCancel
    else Confirm:=True;
end;

function NextButtonClick(CurPageID: Integer): Boolean;
begin
  if CurPageID=wpSelectComponents then begin
     { AMD item }
     VenderIdx:=0;
     if WizardForm.ComponentsList.State[1]=cbChecked then
       VenderIdx:=0;
     if WizardForm.ComponentsList.State[2]=cbChecked then
       VenderIdx:=1;
      //MsgBox(Venderid(''),mberror,MB_ok);
     { check amd }
     if (WizardForm.ComponentsList.State[0]=cbChecked) and RegKeyExists(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Services\'+ahcidrv('')) then begin
       if MsgBox('̹ AMD Ĩ '+ahcidrv('')+' () ġ  ϴ.  Ͻðڽϱ?',mbConfirmation, MB_YESNO or MB_DEFBUTTON2)<>IDYES then begin
         ExitCancel:=False;
         WizardForm.CancelButton.OnClick(nil);
         end;
     end;
     { check intel }
     if (WizardForm.ComponentsList.State[3]=cbChecked) and RegKeyExists(HKEY_LOCAL_MACHINE,'SYSTEM\CurrentControlSet\Services\'+ahcidrvIntel('')) then begin
       if MsgBox('̹ INTEL Ĩ '+ahcidrvIntel('')+' () ġ  ϴ.  Ͻðڽϱ?',mbConfirmation, MB_YESNO or MB_DEFBUTTON2)<>IDYES then begin
         ExitCancel:=False;
         WizardForm.CancelButton.OnClick(nil);
         end;
     end;
  end;
  Result:=True;
end;



[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"
;Name: "korean"; MessagesFile: "compiler:Languages\Korean.isl"

[Types]
Name: "Custom"; Description:"Custom";Flags: iscustom;

[Components]
Name: "AMD"; Description: "AMD"; Types: Custom;
Name: "AMD\A55"; Description: "AMD A55"; Flags: exclusive; Types: Custom;
Name: "AMD\7xx"; Description: "AMD 7xx"; Flags: exclusive; Types: Custom;
Name: "ICH"; Description: "INTEL"; Types: Custom;


[Files]
Source: "x86\ahcix86.sys"; DestDir: "{sys}\drivers"; Check: IsWin32; Flags: 32bit; Components: "AMD\A55";
Source: "x64\ahcix64.sys"; DestDir: "{sys}\drivers"; Check: IsWin64; Flags: 64bit; Components: "AMD\A55";
Source: "7xx\WinXP\x86\ahcix86.sys"; DestDir: "{sys}\drivers"; Check: IsWin32; Flags: 32bit; Components: "AMD\7xx";
Source: "7xx\WinXP\x64\ahcix64.sys"; DestDir: "{sys}\drivers"; Check: IsWin64; Flags: 64bit; Components: "AMD\7xx";
Source: "intel_x86\iaStor.sys"; DestDir: "{sys}\drivers"; Check: IsWin32; Flags: 32bit; Components: "ICH";
Source: "intel_x64\iaStor.sys"; DestDir: "{sys}\drivers"; Check: IsWin64; Flags: 64bit; Components: "ICH";


[Registry]
;-
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrv}"; Components: "AMD"; 
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrv}\Enum"; Components: "AMD";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrv}"; ValueType: dword; ValueName: "Type"; ValueData: "1"; Components: "AMD";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrv}"; ValueType: dword; ValueName: "Start"; ValueData: "0"; Components: "AMD";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrv}"; ValueType: string; ValueName: "Group"; ValueData: "SCSI miniport"; Components: "AMD";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrv}"; ValueType: dword; ValueName: "ErrorControl"; ValueData: "1"; Components: "AMD";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrv}"; ValueType: string; ValueName: "ImagePath"; ValueData: "system32\drivers\{code:ahcidrv}.sys"; Components: "AMD";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrv}"; ValueType: dword; ValueName: "tag"; ValueData: "4"; Components: "AMD";
;-
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrvIntel}"; Components: "ICH";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrvIntel}\Enum"; Components: "ICH";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrvIntel}"; ValueType: dword; ValueName: "Type"; ValueData: "1"; Components: "ICH";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrvIntel}"; ValueType: dword; ValueName: "Start"; ValueData: "0"; Components: "ICH";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrvIntel}"; ValueType: string; ValueName: "Group"; ValueData: "SCSI miniport"; Components: "ICH";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrvIntel}"; ValueType: dword; ValueName: "ErrorControl"; ValueData: "1"; Components: "ICH";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrvIntel}"; ValueType: string; ValueName: "ImagePath"; ValueData: "system32\drivers\{code:ahcidrvIntel}.sys"; Components: "ICH";
Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Services\{code:ahcidrvIntel}"; ValueType: dword; ValueName: "tag"; ValueData: "$19"; Components: "ICH";
;-
;Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\{code:VenderId}"; ValueType: string; ValueName: "Service"; ValueData: "{code:ahcidrv}";
;Root: HKLM; Subkey: "SYSTEM\CurrentControlSet\Control\CriticalDeviceDatabase\{code:VenderId}"; ValueType: string; ValueName: "ClassGUID"; ValueData: "{code:ahciguid}";




